
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>浅谈javascript中的call、apply、bind / 憋错料</title>

    <meta name="description" content="浅谈javascript中的call、apply、bind apply.call 在 javascript 中,call 和 apply 都是为了改变某个函数运行时的上下文(context)而存在的,换句话说,就是为了改变函数体内部 this 的指向. JavaScript 的一大特点是,函数存在「定义时上下文」和「运行时上下文」以及「上下文是可以改变的」这样的概念. 先来一个栗子: function fruits() {} fruits.prototype = { color: &quot;red&quot;, say: function() { co ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">浅谈javascript中的call、apply、bind</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h2>　　apply、call</h2>
<p>　　在 javascript 中，call 和 apply 都是为了改变某个函数运行时的上下文（context）而存在的，换句话说，就是为了改变函数体内部 this 的指向。</p>
<p>　　JavaScript 的一大特点是，函数存在「定义时上下文」和「运行时上下文」以及「上下文是可以改变的」这样的概念。</p>
<p>　　先来一个栗子：</p>
<pre>function fruits() {}

fruits.prototype = {
    color: "red",
    say: function() {
        console.log("My color is " + this.color);
    }
}

var apple = new fruits;
apple.say();    //My color is red</pre>
<p>但是如果我们有一个对象banana= {color : "yellow"}&nbsp;,我们不想对它重新定义 say 方法，那么我们可以通过 call 或 apply 用 apple 的 say 方法：</p>
<pre>banana = {
    color: "yellow"
}
apple.say.call(banana);     //My color is yellow
apple.say.apply(banana);    //My color is yellow</pre>
<p>所以，可以看出 call 和 apply 是为了动态改变 this 而出现的，当一个 object 没有某个方法（本栗子中banana没有say方法），但是其他的有（本栗子中apple有say方法），我们可以借助call或apply用其它对象的方法来操作。</p>
<h3>　　apply、call 的区别</h3>
<p>　　对于 apply、call 二者而言，作用完全一样，只是接受参数的方式不太一样。例如，有一个函数定义如下：</p>
<pre>var func = function(arg1, arg2) {

};</pre>
<p>就可以通过如下方式来调用：</p>
<pre>func.call(this, arg1, arg2);
func.apply(this, [arg1, arg2])</pre>
<p>其中 this 是你想指定的上下文，他可以是任何一个 JavaScript 对象(JavaScript 中一切皆对象)，call 需要把参数按顺序传递进去，而 apply 则是把参数放在数组里。</p>
<p>　　JavaScript 中，某个函数的参数数量是不固定的，因此要说适用条件的话，当你的参数是明确知道数量时用 call 。</p>
<p>　　而不确定的时候用 apply，然后把参数 push 进数组传递进去。当参数数量不确定时，函数内部也可以通过 arguments 这个数组来遍历所有的参数。</p>
<p>　　为了巩固加深记忆，下面列举一些常用用法：</p>
<p>　　1、数组之间追加</p>
<pre>var array1 = [12 , "foo" , {name "Joe"} , -2458];
var array2 = ["Doe" , 555 , 100];
Array.prototype.push.apply(array1, array2);
/* array1 值为  [12 , "foo" , {name "Joe"} , -2458 , "Doe" , 555 , 100] */</pre>
<p>2、获取数组中的最大值和最小值</p>
<pre>var  numbers = [5, 458 , 120 , -215 ];
var maxInNumbers = Math.max.apply(Math, numbers),   //458
    maxInNumbers = Math.max.call(Math,5, 458 , 120 , -215); //458</pre>
<p>　number 本身没有 max 方法，但是 Math 有，我们就可以借助 call 或者 apply 使用其方法。</p>
<p>3、验证是否是数组（前提是toString()方法没有被重写过）</p>
<pre>functionisArray(obj){
    returnObject.prototype.toString.call(obj) === ‘[object Array]‘ ;
}</pre>
<p>4、类（伪）数组使用数组方法</p>
<pre>var domNodes = Array.prototype.slice.call(document.getElementsByTagName("*"));</pre>
<p>Javascript中存在一种名为伪数组的对象结构。比较特别的是&nbsp;arguments 对象，还有像调用&nbsp;getElementsByTagName&nbsp;,&nbsp;document.childNodes&nbsp;之类的，它们返回NodeList对象都属于伪数组。不能应用 Array下的 push , pop 等方法。</p>
<p>　　但是我们能通过 Array.prototype.slice.call 转换为真正的数组的带有 length 属性的对象，这样 domNodes 就可以应用 Array 下的所有方法了。</p>
<h3>　　深入理解运用apply、call</h3>
<p>　　下面就<a href="http://segmentfault.com/a/1190000000375138?page=1" rel="external nofollow noreferrer">借用一道面试题</a>，来更深入的去理解下 apply 和 call 。</p>
<p>　　定义一个 log 方法，让它可以代理 console.log 方法，常见的解决方法是：</p>
<pre>function log(msg)　{
  console.log(msg);
}
log(1);    //1
log(1,2);    //1</pre>
<p>接下来的要求是给每一个 log 消息添加一个"(app)"的前辍，比如：</p>
<pre>log("hello world");    //(app)hello world</pre>
<p>该怎么做比较优雅呢?这个时候需要想到arguments参数是个伪数组，通过 Array.prototype.slice.call 转化为标准数组，再使用数组方法unshift，像这样：</p>
<pre>function log(){
  var args = Array.prototype.slice.call(arguments);
  args.unshift(‘(app)‘);

  console.log.apply(console, args);
};</pre>

<h2>　bind</h2>
<p>　　说完了 apply 和 call ，再来说说bind。bind() 方法与 apply 和 call 很相似，也是可以改变函数体内 this 的指向。</p>
<p>　　MDN的解释是：bind()方法会创建一个新函数，称为绑定函数，当调用这个绑定函数时，绑定函数会以创建它时传入&nbsp;bind()方法的第一个参数作为&nbsp;this，传入&nbsp;bind()&nbsp;方法的第二个以及以后的参数加上绑定函数运行时本身的参数按照顺序作为原函数的参数来调用原函数。</p>
<p>　　直接来看看具体如何使用，在常见的单体模式中，通常我们会使用 _this , that , self 等保存 this ，这样我们可以在改变了上下文之后继续引用到它。&nbsp;像这样：</p>
<pre>var foo = {
    bar : 1,
    eventBind: function(){
        var _this = this;
        $(‘.someClass‘).on(‘click‘,function(event) {
            /* Act on the event */
            console.log(_this.bar);     //1
        });
    }
}</pre>
<p>由于 Javascript 特有的机制，上下文环境在 eventBind:function(){ } 过渡到&nbsp;$(‘.someClass‘).on(‘click‘,function(event) {&nbsp;}) 发生了改变，上述使用变量保存 this&nbsp;这些方式都是有用的，也没有什么问题。当然使用 bind() 可以更加优雅的解决这个问题：</p>
<pre>var foo = {
    bar : 1,
    eventBind: function(){
        $(‘.someClass‘).on(‘click‘,function(event) {
            /* Act on the event */
            console.log(this.bar);      //1
        }.bind(this));
    }
}</pre>
<p>在上述代码里，bind() 创建了一个函数，当这个click事件绑定在被调用的时候，它的 this 关键词会被设置成被传入的值（这里指调用bind()时传入的参数）。因此，这里我们传入想要的上下文 this(其实就是 foo )，到 bind() 函数中。然后，当回调函数被执行的时候， this 便指向&nbsp;foo&nbsp;对象。再来一个简单的栗子：</p>
<pre>var bar = function(){
console.log(this.x);
}
var foo = {
x:3
}
bar(); // undefined
var func = bar.bind(foo);
func(); // 3</pre>
<p>这里我们创建了一个新的函数 func，当使用 bind() 创建一个绑定函数之后，它被执行的时候，它的 this 会被设置成 foo ， 而不是像我们调用 bar() 时的全局作用域。</p>
<p>　　有个有趣的问题，如果连续 bind() 两次，亦或者是连续 bind() 三次那么输出的值是什么呢？像这样：</p>
<pre>var bar = function(){
    console.log(this.x);
}
var foo = {
    x:3
}
var sed = {
    x:4
}
var func = bar.bind(foo).bind(sed);
func(); //?

var fiv = {
    x:5
}
var func = bar.bind(foo).bind(sed).bind(fiv);
func(); //?</pre>
<p>答案是，两次都仍将输出 3 ，而非期待中的 4 和 5 。原因是，在Javascript中，多次 bind() 是无效的。更深层次的原因， bind() 的实现，相当于使用函数在内部包了一个 call / apply ，第二次 bind() 相当于再包住第一次 bind() ,故第二次以后的 bind 是无法生效的。</p>
<h2>apply、call、bind比较</h2>
<p>　　那么 apply、call、bind 三者相比较，之间又有什么异同呢？何时使用 apply、call，何时使用 bind 呢。简单的一个栗子：</p>
<pre>var obj = {
    x: 81,
};

var foo = {
    getX: function() {
        return this.x;
    }
}

console.log(foo.getX.bind(obj)());  //81
console.log(foo.getX.call(obj));    //81
console.log(foo.getX.apply(obj));   //81</pre>
<p>三个输出的都是81，但是注意看使用 bind() 方法的，他后面多了对括号。</p>
<p>　　也就是说，区别是，当你希望改变上下文环境之后并非立即执行，而是回调执行的时候，使用 bind() 方法。而 apply/call 则会立即执行函数。</p>
<p>　　再总结一下：</p>
<ul>
<li>apply 、 call 、bind 三者都是用来改变函数的this对象的指向的；</li>
<li>apply 、 call 、bind 三者第一个参数都是this要指向的对象，也就是想指定的上下文；</li>
<li>apply 、 call 、bind 三者都可以利用后续参数传参；</li>
<li>bind&nbsp;是返回对应函数，便于稍后调用；apply 、call 则是立即调用 。</li>
</ul>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 07:29:05 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e5%9b%ba%e5%ae%9a/" title="固定">固定</a>, <a href="https://www.biecuoliao.com/tag/%e5%ae%9e%e7%8e%b0/" title="实现">实现</a>, <a href="https://www.biecuoliao.com/tag/%e6%89%a7%e8%a1%8c/" title="执行">执行</a>, <a href="https://www.biecuoliao.com/tag/%e6%8c%87%e5%ae%9a/" title="指定">指定</a>, <a href="https://www.biecuoliao.com/tag/%e4%b9%8b%e9%97%b4/" title="之间">之间</a>, <a href="https://www.biecuoliao.com/tag/rgs/" title="rgs">rgs</a>, <a href="https://www.biecuoliao.com/tag/%e7%bb%91%e5%ae%9a/" title="绑定">绑定</a>, <a href="https://www.biecuoliao.com/tag/%e9%9d%a2%e8%af%95%e9%a2%98/" title="面试题">面试题</a>, <a href="https://www.biecuoliao.com/tag/unshift/" title="unshift">unshift</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>浅谈javascript中的call、apply、bind的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bz1Yp0.html" rel="bookmark">浅谈JavaScript中的原型模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在JavaScript中创建对象由很多种方式,如工厂模式.构造函数模式.原型模式等: &lt;pre name=&quot;code&quot; class=&quot;html&quot;&gt;//工厂模式 function createPerson(name,age,job) { var o = new Object; o.name = name; o.age = age; o.job = job; o.sayName = function() { alert(this.name); } retur			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVNEppM.html" rel="bookmark">深入浅出：了解JavaScript中的call&comma;apply&comma;bind的差别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在 javascript之 this 关键字详解文章中,谈及了如下内容,做一个简单的回顾: 1.this对象的涵义就是指向当前对象中的属性和方法. 2.this指向的可变性.当在全局作用域时,this指向全局:当在某个对象中使用this时,this指向该对象:当把某个对象的方法赋值给      另外一个对象时,this会指向后一个对象. 3.this的使用场合有:在全局环境中使用:在构造函数中使用,在对象的方法中使用. 4.this的使用注意点,最重要的一点就是要避免多层嵌套使用this对象.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/VMGpZG0.html" rel="bookmark">浅谈JavaScript中继承的实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  谈到js中的面向对象编程,都有一个共同点,选择原型属性还是构造函数,两者各有利弊,而就片面的从js的对象创建以及继承的实现两个方面来说,官方所推荐的是两个相结合,各尽其责,各取其长,在前面的例子中,我已就在JavaScript中对象创建的方法做了一些总结,下面就其继承来道说一二:   1:原型链继承: 每一个构造函数都有一个原型对象,原型对象都包含一个指向构造函数的指针,而实例都包含一个指向原型对象内部的指针(默认的原型,所有默认类型都继承了Object,而这个继承也是用过原型链实现) fu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eqZrp0.html" rel="bookmark">别真以为JavaScript中func&period;call&sol;apply&sol;bind是万能的！</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				自从学会call/apply/bind这三个方法后我就各种场合各种使用各种得心应手至今还没踩过什么坑,怎么用?说直白点就是我自己的对象没有某个方法但别人有,我就可以通过call/apply/bind去调用执行别人家的方法,不太懂具体用法的同学可移至MDN学习一下Function.prototype.call() Function.prototype.apply() Function.prototype.bind() ,本文不讲解使用,但是这三个方法并不是万能的,并不一定会执行你想要的那个函数,因			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mz6WQOM.html" rel="bookmark">javascript中的call&lpar;&rpar;&comma;apply&lpar;&rpar;&comma;bind&lpar;&rpar;方法的区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				之前一直迷惑,记不住call(),apply(),bind()的区别.不知道如何使用,一直处于懵懂的状态.直到有一天面试被问到了这三个方法的区别,所以觉得很有必要总结一下. 如果有不全面的地方,后续再进行补充. 1. 改变this的指向 var obj = { name : '张三', age : 17, myFun : function () { console.log(this.name + ' ' + this.age); } } var obj2 = { name : '李四', age			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/416pGOM.html" rel="bookmark">浅谈Javascript中的原型、原型链、继承</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				构造函数,原型,实例三者的关系 构造函数: 构造函数是创建对象的一种常用方式, 其他创建对象的方式还包括工厂模式, 原型模式, 对象字面量等.我们来看一个简单的构造函数: function Product (name, role){ //构造函数的命名约定第一个字母使用大写的形式! this.name = name; this.role = role; } ( 1 ) 每一个构造函数都有一个prototype属性,我们可以在Chorme控制台中打印出Product.prototype属性. (			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M68l5d3.html" rel="bookmark">浅谈javascript中的闭包</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引入定义:闭包只有权访问另一个函数中的作用域中的函数. 简单点说,就是当某函数a执行完毕后,闭包不会使得GC(JavaScript的回收机制)去回收a所占用的资源,因为a的内部函数b的执行需要依赖a中的变量. 代码示例: window.onload = function(){ function createComparisonFunction(propertyName){ return function(object1, object2){ var value1 = object1[proper			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Qqj8E4.html" rel="bookmark">浅谈javascript中的For in语法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				相信大家都使用过javascript中的for循环,主要用来遍历数组对象,方便执行重复操作,体现代码的重用性.但是,应为数组的索引一般是整 型的数字,当遇到JSON对象或者object对象时,就不能使用for循环遍历了,应当使用for in函数遍历对象,这里就谈谈个人对for in的理解. 首先,虽然叫For in语法但关键字还是用for,这个语法还可以用来遍历对象,拿到的是对象的属性名称,然后通过对象名[属性名称]就可以拿到对象.个人觉得,理解这个语法的本质,关键在于理解每次循环得到的到底是什			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3v5ZRR0.html" rel="bookmark">浅谈JavaScript中的函数问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前面的话:JavaScript可运行在所有主要平台的主流浏览器上,也可运行在每一个主流操作系统的服务器端上.所以呢,要想成为一名优秀的全栈工程师,必须懂得JavaScript语言.这是我整理的JS的部分函数问题,供大家参考借阅,有不妥的地方也请多多指教. 1.函数的三要素    1.1 函数的功能   1.2 函数的参数 a. 形参——定义函数的时候,没有实际的值,给实参占位 b. 实参——调用函数的时候,有实际的值: c. 当调用函数的时候会把实参复制一份传递给函数 d. 函数调用的时候,实参			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/V0bdy94.html" rel="bookmark" class="title">python的注释</a>
					<div>
						一.python单行注释符号(#) 井号(#)常被用作单行注释符号,在代码中使用#时,它右边的任何数据都会被忽略,当做是注释.print 1 #输出1#号右边的内容在执行的时候是不会被输出的. 二.批 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/v0kvELM.html" rel="bookmark" class="title">类的组合</a>
					<div>
						1.类的组合:类中的成员数据是另一个类的对象.类组合的构造函数:原则:不仅要负责对本类中的基本类型成员数据赋初值,也要对对象成员初始化. 2.构造函数的调用顺序: 1.调用内嵌对象的构造函数(按内嵌时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXdDOaM.html" rel="bookmark" class="title">Sqlite使用</a>
					<div>
						安装命令行工具从http://www.sqlite.org/download.html下载Precompiled Binaries for Windows下的sqlite-tools-win32-x8 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qoJp7M.html" rel="bookmark" class="title">机器学习读书笔记01 机器学习基础</a>
					<div>
						顾名思义,机器学习的目的就是让机器具有类似于人类的学习.认识.理解事物的能力.试想一下,如果计算机能够对大量的癌症治疗记录进行归纳和总结,并能够给医生提出适当的建议和意见,那对病人的康复来说,是多么的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49on810.html" rel="bookmark" class="title">linux下安装jdk8</a>
					<div>
						1.下载jdk8安装包 http://www.oracle.com/technetwork/java/javase/downloads/jdk8-downloads-2133151.html 2.拷贝 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e5jJD0.html" rel="bookmark" class="title">线程浅析</a>
					<div>
						1.进程与线程 一个进程包含多个线程.可以把进程当做一个应用程序. 操作系统分配一段时间给一个进程,让CPU执行该进程.进程再将时间片段分割给各个线程 2.创建线程(Thread)的方法 //方法一  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aApLq0.html" rel="bookmark" class="title">第二个UI脚本--Python&plus;selenium之unittest&plus;HTMLtestRunner及python的继承</a>
					<div>
						前面有一篇对于常见元素的识别和操作的python自动化脚本,这一篇就接着聊下python的类继承,已经它的第三款unittest框架,和报告收集包HTMLtestRunner的应用. 还是直接上代码吧 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyWBYa3.html" rel="bookmark" class="title">Hibernate学习（四）</a>
					<div>
						映射关系(关联映射,使用xml文件进行配置) (1)一对一映射(一个公司对应一个地址,地址和公司的关系是一对一) 第一步:建立类 公司类: //一对一 xml配置 public class Compa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPw7d14.html" rel="bookmark" class="title">dubbo与spring mvc</a>
					<div>
						安装 一.本地服务 1.定义服务接口: (该接口需单独打包,在服务提供方和消费方共享) public interface CustomerService { public String getName ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mymb6eM.html" rel="bookmark" class="title">Dell 灵越 5545</a>
					<div>
						前言:电脑的中轴坏掉了, 售后略贵不说,最重要的是维修周期太长,因此决定自己来拆机更换相应的部件. 我的电脑是C壳,D壳之间连接部分坏掉了,需要将C,D壳拆解下来更换上新的壳. 准备工作:需要一套电脑 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzEw6y4.html" rel="bookmark" class="title">01&colon;查找最接近的元素</a>
					<div>
						http://noi.openjudge.cn/ch0111/01/ 01:查找最接近的元素 总时间限制:  1000ms 内存限制:  65536kB 描述 在一个非降序列中,查找与给定值最接近的元 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBWRZj0.html" rel="bookmark" class="title">第一次读懂Thinking in java 感悟</a>
					<div>
						之前初学java的时候,我买了一本Thinking In Java 回来,但是之前一口气读了几页下来,发现很生涩难懂,到后来经过一段时间的java代码练习之后,在这个安静的下午,我开始静下心来看Thi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rBqzv3.html" rel="bookmark" class="title">实验作业：使gdb跟踪分析一个系统调用内核函数</a>
					<div>
						实验作业:使gdb跟踪分析一个系统调用内核函数(我使用的是getuid) 20135313吴子怡.北京电子科技学院 [第一部分] 根据视频演示的步骤,先做第一部分,步骤如下 ①更新menu代码到最新版 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Oy1pZM.html" rel="bookmark" class="title">为什么每个前端开发者都要理解页面的渲染？（转载 学习中。。。）</a>
					<div>
						文章转载自:开源中国社区 [http://www.oschina.net] 今天我要将关注点放到页面渲染以及其重要性上.虽然已经有很多文章提到过这个主题了,但大部分信息都是零碎的片段.为了思考这件事情 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NyODB3.html" rel="bookmark" class="title">WPF笔记&lpar;1&period;10 绘图&rpar;&mdash;&mdash;Hello，WPF！</a>
					<div>
						原文:WPF笔记(1.10 绘图)--Hello,WPF! 书中的代码语法过时了,改写为以下(测试通过):         &lt;Button&gt;            &lt;Button.L ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vAEjX0.html" rel="bookmark" class="title">system 函数</a>
					<div>
						1.函数详解 system函数需加头文件&lt;stdlib.h&gt;后方可调用 功能:发出一个DOS命令用法:int system(char *command); 程序例: 1 #include  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NXNwG0.html" rel="bookmark" class="title">地球物理基本概念笔记</a>
					<div>
						1.瑞克子波 雷克子波是地震子波中的一种. 由震源激发.经地下传播并被人们在地面或井中接收到的地震波通常是一个短的脉冲振动,称该振动为振动子波.它可以理解为有确定起始时间和有限能量,在很短 时间内衰减 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgQaaB3.html" rel="bookmark" class="title">如何使你的Ajax应用内容可让搜索引擎爬行</a>
					<div>
						This document outlines the steps that are necessary in order to make your AJAX application crawlable ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3w5W8jM.html" rel="bookmark" class="title">iOS进度条显示</a>
					<div>
						一.实现下载文件进度控制 1.代码示例 1 #import &quot;YYViewController.h&quot; 2 3 @interface YYViewController () 4 @p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41n2GXM.html" rel="bookmark" class="title">Ubuntu中用xampp搭建服务器时外网无法访问phpmyadmin的问题</a>
					<div>
						Ubuntu中xampp一般安装在/opt/lampp/目录下,用[ip]/phpmyadmin访问若出现访问禁止,则可以通过修改一下配置文件解决 打开/opt/lampp/etc/extra/htt ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
